﻿using FarseerGames.FarseerPhysics.Collisions;
using FarseerGames.FarseerPhysics.Mathematics;

namespace FreeGoo.GameEngine.Renderables.Particles
{
    public class FixedHook : Particle
    {
        public FixedHook(Geom geom, float radius)
            : base(geom, radius)
        {
            geom.Body.IsStatic = true;
            MinimumLinkTargets = 1;
        }

        public override void Selected(Vector2 cursorPosition)
        {
            // Ignore inherited behaviour
        }

        public override bool AllowsLinkFrom(ILinkable linkable)
        {
            return true;
        }

        public override bool AllowsLinkTo(ILinkable linkable)
        {
            return false;
        }
    }
}
