﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FarseerGames.FarseerPhysics.Collisions;
using FreeGoo.GameEngine.Renderables.Links;

namespace FreeGoo.GameEngine.Renderables.Particles
{
    public class Rope : Particle
    {
        public Rope(Geom geom, float radius)
            : base(geom, radius)
        {
            MinimumLinkTargets = 1;
            MaximumLinkTargets = 1;
            LinkableDistanceLinkBias = 1;
            LinkBreakpointFactor = LinkBreakpointFactor * 2f;
        }

        protected override Link CreateActualLink(ILinkable first, ILinkable second)
        {
            return MixedFactory.CreateStringLinkBetweenLinkableObjects(Engine, first, second, this);
        }        
    }
}
