﻿using System.Xml.Linq;
using FarseerGames.FarseerPhysics.Mathematics;
using FreeGoo.GameEngine;
using FreeGoo.GameEngine.Renderables;
using FreeGoo.GameEngine.Renderables.BodyHookOwners;

namespace FreeGoo.LevelClasses.LevelParts.BodyHookOwners
{
    public class KeyedMotorLevelPart : BodyRenderableLevelPart
    {
        public override string Name { get { return "KeyedMotor"; } }

        public override BodyRenderable BuildBodyRenderable(Level level, XElement element)
        {
            KeyedMotor keyedMotor;
            Vector2 position = GetOffsetPosition(level, element);
            float hookRadius = element.Attribute("BodyHookRadius").ToFloat(150);
            int hookCount = element.Attribute("BodyHookCount").ToInt(6);

            keyedMotor = MixedFactory.CreateKeyedMotor(
                level.Engine,
                position,
                hookRadius,
                hookCount);
            keyedMotor.TargetAngularVelocity = 0;
            keyedMotor.WantedAngularVelocityWhenRunning = 3;
            return keyedMotor;
        }
    }
}
