﻿using FreeGoo.GameEngine.Interfaces;
using FreeGoo.GameEngine.Renderables;

namespace FreeGoo.WpfRenderer
{
    public abstract class Renderer : IRenderer
    {
        public Renderer(RendererFactory factory, Renderable renderable)
        {
            Factory = factory;
            Renderable = renderable;
        }

        public Renderable Renderable { get; set; }
        public RendererFactory Factory { get; set; }

        public abstract void Update();
        public abstract void Delete();
        public abstract void StateChanged();
    }
}
